#ifdef Plan9
#include <u.h>
#include <libc.h>
#define do_seek(a, b, c)	seek((a), (b), (c))
#endif

#ifdef Posix
#include <stdlib.h>
#include <unistd.h>
#define nelem(x)	(sizeof((x))/sizeof((x)[0]))
#define do_seek(a, b, c)	lseek((a), (b), (c))
#endif

#include "dat.h"

void
main(void)
{
	int i;

	for(i=0; statfn[i]; i++)
		statfn[i](1);

	for(;;){
		for(i=0; statfn[i]; i++)
			if(statfn[i](0) < 0)
				break;
	}
	exits(0);
}

char buf[16384];
char *line[100];
char *tok[100];
int nline, ntok;

void
readfile(int fd)
{
	int n;

	if(fd == -1){
		nline = 0;
		return;
	}

	do_seek(fd, 0, 0);
	n = read(fd, buf, sizeof buf-1);
	if(n < 0)
		n = 0;
	buf[n] = 0;

	nline = gettokens(buf, line, nelem(line), "\n");
}

void
tokens(int i)
{
	if(i >= nline){
		ntok = 0;
		return;
	}
	ntok = tokenize(line[i], tok, nelem(tok));
}

